// A Bison parser, made by GNU Bison 3.7.6.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 1 "xproto.y"

/*
 *  Copyright (C) 2017-2021, Thomas Maier-Komor
 *
 *  This source file belongs to Wire-Format-Compiler.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#define YYDEBUG 1
#include "Message.h"
#include "Options.h"
#include "KVPair.h"
#include "PBFile.h"
#include "ProtoDriver.h"
#include "Field.h"
#include "Enum.h"
#include "log.h"
#include <set>
#include <string>


using namespace std;


#line 78 "xproto.cc"


#include "xproto.h"


// Unqualified %code blocks.
#line 54 "xproto.y"

#include "ProtoDriver.h"

#line 89 "xproto.cc"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

namespace yy {
#line 181 "xproto.cc"

  /// Build a parser object.
  ProtoParser::ProtoParser (ProtoDriver &drv_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      drv (drv_yyarg)
  {}

  ProtoParser::~ProtoParser ()
  {}

  ProtoParser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/

  // basic_symbol.
  template <typename Base>
  ProtoParser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value (that.value)
    , location (that.location)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  ProtoParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_MOVE_REF (location_type) l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  ProtoParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_RVREF (semantic_type) v, YY_RVREF (location_type) l)
    : Base (t)
    , value (YY_MOVE (v))
    , location (YY_MOVE (l))
  {}

  template <typename Base>
  ProtoParser::symbol_kind_type
  ProtoParser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

  template <typename Base>
  bool
  ProtoParser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  ProtoParser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    value = YY_MOVE (s.value);
    location = YY_MOVE (s.location);
  }

  // by_kind.
  ProtoParser::by_kind::by_kind ()
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  ProtoParser::by_kind::by_kind (by_kind&& that)
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  ProtoParser::by_kind::by_kind (const by_kind& that)
    : kind_ (that.kind_)
  {}

  ProtoParser::by_kind::by_kind (token_kind_type t)
    : kind_ (yytranslate_ (t))
  {}

  void
  ProtoParser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  ProtoParser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  ProtoParser::symbol_kind_type
  ProtoParser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }

  ProtoParser::symbol_kind_type
  ProtoParser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  // by_state.
  ProtoParser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  ProtoParser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  ProtoParser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  ProtoParser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  ProtoParser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  ProtoParser::symbol_kind_type
  ProtoParser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  ProtoParser::stack_symbol_type::stack_symbol_type ()
  {}

  ProtoParser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.value), YY_MOVE (that.location))
  {
#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  ProtoParser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.value), YY_MOVE (that.location))
  {
    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  ProtoParser::stack_symbol_type&
  ProtoParser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }

  ProtoParser::stack_symbol_type&
  ProtoParser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  ProtoParser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    YY_USE (yysym.kind ());
  }

#if YYDEBUG
  template <typename Base>
  void
  ProtoParser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  ProtoParser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  ProtoParser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  ProtoParser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  ProtoParser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  ProtoParser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  ProtoParser::debug_level_type
  ProtoParser::debug_level () const
  {
    return yydebug_;
  }

  void
  ProtoParser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  ProtoParser::state_type
  ProtoParser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  ProtoParser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  ProtoParser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  ProtoParser::operator() ()
  {
    return parse ();
  }

  int
  ProtoParser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 52 "xproto.y"
{ yyla.location.begin.filename = yyla.location.end.filename = &drv.filename; }

#line 517 "xproto.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, drv));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;

      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // Quantifier_P: OPTIONAL
#line 103 "xproto.y"
                        { (yylhs.value.quant) = q_optional; }
#line 655 "xproto.cc"
    break;

  case 3: // Quantifier_P: REQUIRED
#line 104 "xproto.y"
                        { (yylhs.value.quant) = q_required; }
#line 661 "xproto.cc"
    break;

  case 4: // Quantifier_P: REPEATED
#line 105 "xproto.y"
                        { (yylhs.value.quant) = q_repeated; }
#line 667 "xproto.cc"
    break;

  case 5: // Quantifier_P: %empty
#line 106 "xproto.y"
                        { (yylhs.value.quant) = q_unspecified; }
#line 673 "xproto.cc"
    break;

  case 6: // Type_P: INT32
#line 109 "xproto.y"
                        { (yylhs.value.type) = ft_int32; }
#line 679 "xproto.cc"
    break;

  case 7: // Type_P: UINT32
#line 110 "xproto.y"
                        { (yylhs.value.type) = ft_uint32; }
#line 685 "xproto.cc"
    break;

  case 8: // Type_P: SINT32
#line 111 "xproto.y"
                        { (yylhs.value.type) = ft_sint32; }
#line 691 "xproto.cc"
    break;

  case 9: // Type_P: INT64
#line 112 "xproto.y"
                        { (yylhs.value.type) = ft_int64; }
#line 697 "xproto.cc"
    break;

  case 10: // Type_P: UINT64
#line 113 "xproto.y"
                        { (yylhs.value.type) = ft_uint64; }
#line 703 "xproto.cc"
    break;

  case 11: // Type_P: SINT64
#line 114 "xproto.y"
                        { (yylhs.value.type) = ft_sint64; }
#line 709 "xproto.cc"
    break;

  case 12: // Type_P: INT16
#line 115 "xproto.y"
                        { (yylhs.value.type) = ft_int16; }
#line 715 "xproto.cc"
    break;

  case 13: // Type_P: UINT16
#line 116 "xproto.y"
                        { (yylhs.value.type) = ft_uint16; }
#line 721 "xproto.cc"
    break;

  case 14: // Type_P: SINT16
#line 117 "xproto.y"
                        { (yylhs.value.type) = ft_sint16; }
#line 727 "xproto.cc"
    break;

  case 15: // Type_P: INT8
#line 118 "xproto.y"
                        { (yylhs.value.type) = ft_int8; }
#line 733 "xproto.cc"
    break;

  case 16: // Type_P: UINT8
#line 119 "xproto.y"
                        { (yylhs.value.type) = ft_uint8; }
#line 739 "xproto.cc"
    break;

  case 17: // Type_P: SINT8
#line 120 "xproto.y"
                        { (yylhs.value.type) = ft_sint8; }
#line 745 "xproto.cc"
    break;

  case 18: // Type_P: FLOAT
#line 121 "xproto.y"
                        { (yylhs.value.type) = ft_float; }
#line 751 "xproto.cc"
    break;

  case 19: // Type_P: DOUBLE
#line 122 "xproto.y"
                        { (yylhs.value.type) = ft_double; }
#line 757 "xproto.cc"
    break;

  case 20: // Type_P: STRING
#line 123 "xproto.y"
                        { (yylhs.value.type) = ft_string; }
#line 763 "xproto.cc"
    break;

  case 21: // Type_P: BYTES
#line 124 "xproto.y"
                        { (yylhs.value.type) = ft_bytes; }
#line 769 "xproto.cc"
    break;

  case 22: // Type_P: BOOL
#line 125 "xproto.y"
                        { (yylhs.value.type) = ft_bool; }
#line 775 "xproto.cc"
    break;

  case 23: // Type_P: FIXED8
#line 126 "xproto.y"
                        { (yylhs.value.type) = ft_fixed8; }
#line 781 "xproto.cc"
    break;

  case 24: // Type_P: SFIXED8
#line 127 "xproto.y"
                        { (yylhs.value.type) = ft_sfixed8; }
#line 787 "xproto.cc"
    break;

  case 25: // Type_P: FIXED16
#line 128 "xproto.y"
                        { (yylhs.value.type) = ft_fixed16; }
#line 793 "xproto.cc"
    break;

  case 26: // Type_P: SFIXED16
#line 129 "xproto.y"
                        { (yylhs.value.type) = ft_sfixed16; }
#line 799 "xproto.cc"
    break;

  case 27: // Type_P: FIXED32
#line 130 "xproto.y"
                        { (yylhs.value.type) = ft_fixed32; }
#line 805 "xproto.cc"
    break;

  case 28: // Type_P: SFIXED32
#line 131 "xproto.y"
                        { (yylhs.value.type) = ft_sfixed32; }
#line 811 "xproto.cc"
    break;

  case 29: // Type_P: FIXED64
#line 132 "xproto.y"
                        { (yylhs.value.type) = ft_fixed64; }
#line 817 "xproto.cc"
    break;

  case 30: // Type_P: SFIXED64
#line 133 "xproto.y"
                        { (yylhs.value.type) = ft_sfixed64; }
#line 823 "xproto.cc"
    break;

  case 31: // Type_P: UNSIGNED
#line 134 "xproto.y"
                        { (yylhs.value.type) = ft_unsigned; }
#line 829 "xproto.cc"
    break;

  case 32: // Type_P: SIGNED
#line 135 "xproto.y"
                        { (yylhs.value.type) = ft_signed; }
#line 835 "xproto.cc"
    break;

  case 33: // Type_P: INT
#line 136 "xproto.y"
                        { (yylhs.value.type) = ft_int; }
#line 841 "xproto.cc"
    break;

  case 34: // Type_P: MSGNAME
#line 137 "xproto.y"
                        { (yylhs.value.type) = (yystack_[0].value.msgid); }
#line 847 "xproto.cc"
    break;

  case 35: // Type_P: ENUMNAME
#line 138 "xproto.y"
                        { (yylhs.value.type) = (yystack_[0].value.enumid); }
#line 853 "xproto.cc"
    break;

  case 36: // IntLit_P: DECLIT
#line 142 "xproto.y"
        { (yylhs.value.intlit).str = (yystack_[0].value.id).str; (yylhs.value.intlit).len = (yystack_[0].value.id).len; }
#line 859 "xproto.cc"
    break;

  case 37: // IntLit_P: HEXLIT
#line 144 "xproto.y"
        { (yylhs.value.intlit).str = (yystack_[0].value.id).str; (yylhs.value.intlit).len = (yystack_[0].value.id).len; }
#line 865 "xproto.cc"
    break;

  case 38: // IntLit_P: OCTLIT
#line 146 "xproto.y"
        { (yylhs.value.intlit).str = (yystack_[0].value.id).str; (yylhs.value.intlit).len = (yystack_[0].value.id).len; }
#line 871 "xproto.cc"
    break;

  case 39: // Option_P: IDENTIFIER EQUAL OptionArg_P
#line 150 "xproto.y"
        { (yylhs.value.kvpair) = new KVPair((yystack_[2].value.id).str,(yystack_[2].value.id).len,(yystack_[0].value.id).str,(yystack_[0].value.id).len); }
#line 877 "xproto.cc"
    break;

  case 40: // OptionList_P: Option_P
#line 155 "xproto.y"
        { (yylhs.value.kvpair) = (yystack_[0].value.kvpair); }
#line 883 "xproto.cc"
    break;

  case 41: // OptionList_P: OptionList_P COMMA Option_P
#line 157 "xproto.y"
        { (yystack_[0].value.kvpair)->setNext((yystack_[2].value.kvpair)); (yylhs.value.kvpair) = (yystack_[0].value.kvpair); }
#line 889 "xproto.cc"
    break;

  case 42: // OptionArg_P: IDENTIFIER
#line 162 "xproto.y"
        { (yylhs.value.id) = (yystack_[0].value.id); }
#line 895 "xproto.cc"
    break;

  case 43: // OptionArg_P: IDREF
#line 164 "xproto.y"
        { (yylhs.value.id) = (yystack_[0].value.id); }
#line 901 "xproto.cc"
    break;

  case 44: // OptionArg_P: SYSINC
#line 166 "xproto.y"
        { (yylhs.value.id) = (yystack_[0].value.id); }
#line 907 "xproto.cc"
    break;

  case 45: // OptionArg_P: STRINGLIT
#line 168 "xproto.y"
        { (yylhs.value.id) = (yystack_[0].value.id); }
#line 913 "xproto.cc"
    break;

  case 46: // OptionArg_P: DECLIT
#line 170 "xproto.y"
        { (yylhs.value.id) = (yystack_[0].value.id); }
#line 919 "xproto.cc"
    break;

  case 47: // OptionArg_P: HEXLIT
#line 172 "xproto.y"
        { (yylhs.value.id) = (yystack_[0].value.id); }
#line 925 "xproto.cc"
    break;

  case 48: // OptionArg_P: OCTLIT
#line 174 "xproto.y"
        { (yylhs.value.id) = (yystack_[0].value.id); }
#line 931 "xproto.cc"
    break;

  case 49: // OptionArg_P: FIXED8
#line 176 "xproto.y"
        { (yylhs.value.id) = (yystack_[0].value.id); }
#line 937 "xproto.cc"
    break;

  case 50: // OptionArg_P: FIXED16
#line 178 "xproto.y"
        { (yylhs.value.id) = (yystack_[0].value.id); }
#line 943 "xproto.cc"
    break;

  case 51: // OptionArg_P: FIXED32
#line 180 "xproto.y"
        { (yylhs.value.id) = (yystack_[0].value.id); }
#line 949 "xproto.cc"
    break;

  case 52: // OptionArg_P: FIXED64
#line 182 "xproto.y"
        { (yylhs.value.id) = (yystack_[0].value.id); }
#line 955 "xproto.cc"
    break;

  case 53: // TargetOptions_P: OPTION IDENTIFIER LBRACE
#line 187 "xproto.y"
        { (yylhs.value.options) = new Options(string((yystack_[1].value.id).str,(yystack_[1].value.id).len),Options::getDefaults()); }
#line 961 "xproto.cc"
    break;

  case 54: // TargetOptions_P: OPTION IDENTIFIER COLON IDENTIFIER LBRACE
#line 189 "xproto.y"
        { (yylhs.value.options) = new Options(string((yystack_[3].value.id).str,(yystack_[3].value.id).len),drv.getFile()->getTarget((yystack_[1].value.id).str,(yystack_[1].value.id).len)); }
#line 967 "xproto.cc"
    break;

  case 55: // TargetOptions_P: TargetOptions_P Option_P SEMI
#line 191 "xproto.y"
        { (yylhs.value.options) = (yystack_[2].value.options); (yylhs.value.options)->add((yystack_[1].value.kvpair)); }
#line 973 "xproto.cc"
    break;

  case 56: // TargetOptions_P: TargetOptions_P NODEREF COLON OptionList_P SEMI
#line 193 "xproto.y"
        { (yylhs.value.options) = (yystack_[4].value.options); (yylhs.value.options)->add(string((yystack_[3].value.id).str,(yystack_[3].value.id).len),(yystack_[1].value.kvpair)); }
#line 979 "xproto.cc"
    break;

  case 57: // Target_P: TargetOptions_P RBRACE
#line 197 "xproto.y"
        { (yylhs.value.options) = (yystack_[1].value.options); }
#line 985 "xproto.cc"
    break;

  case 58: // EnumDef_P: ENUM IDENTIFIER LBRACE
#line 202 "xproto.y"
        { (yylhs.value.edef) = Enum::create((yystack_[1].value.id).str,(yystack_[1].value.id).len); }
#line 991 "xproto.cc"
    break;

  case 59: // EnumDef_P: ENUM ENUMNAME LBRACE
#line 204 "xproto.y"
        { (yylhs.value.edef) = Enum::create(Enum::resolveId((yystack_[1].value.enumid))); }
#line 997 "xproto.cc"
    break;

  case 60: // EnumDef_P: EnumDef_P IDENTIFIER EQUAL IntLit_P SEMI
#line 206 "xproto.y"
        { (yystack_[4].value.edef)->add((yystack_[3].value.id).str,(yystack_[3].value.id).len,(yystack_[1].value.intlit).str,(yystack_[1].value.intlit).len); (yylhs.value.edef) = (yystack_[4].value.edef); }
#line 1003 "xproto.cc"
    break;

  case 61: // EnumDef_P: EnumDef_P IDENTIFIER EQUAL IntLit_P OPTSTART STRING EQUAL STRINGLIT OPTEND SEMI
#line 208 "xproto.y"
        {	(yystack_[9].value.edef)->add((yystack_[8].value.id).str,(yystack_[8].value.id).len,(yystack_[6].value.intlit).str,(yystack_[6].value.intlit).len);
		(yystack_[9].value.edef)->setStringValue((yystack_[6].value.intlit).str,(yystack_[2].value.id).str,(yystack_[2].value.id).len); (yylhs.value.edef) = (yystack_[9].value.edef); }
#line 1010 "xproto.cc"
    break;

  case 62: // EnumDef_P: EnumDef_P OPTION IDENTIFIER EQUAL OptionArg_P SEMI
#line 211 "xproto.y"
        { (yylhs.value.edef) = (yystack_[5].value.edef); (yylhs.value.edef)->setOption((yystack_[3].value.id).str,(yystack_[3].value.id).len,(yystack_[1].value.id).str,(yystack_[1].value.id).len); }
#line 1016 "xproto.cc"
    break;

  case 63: // Enum_P: EnumDef_P RBRACE
#line 215 "xproto.y"
        { (yylhs.value.edef) = (yystack_[1].value.edef); }
#line 1022 "xproto.cc"
    break;

  case 64: // FieldSpec_P: Quantifier_P Type_P IDENTIFIER EQUAL IntLit_P
#line 220 "xproto.y"
        {
		switch (drv.getProtocol()) {
		default:
			abort();
		case gprotov2:
			if ((yystack_[4].value.quant) == q_unspecified) {
				::error("missing quantifier");
				(yystack_[4].value.quant) = q_optional;
			}
			break;
		case gprotov3:
			if (((yystack_[4].value.quant) == q_optional) || ((yystack_[4].value.quant) == q_required)) {
				::error("keywords required/optional invalid for protoV3");
				(yystack_[4].value.quant) = q_optional;
			}
			break;
		case xprotov1:
			if ((yystack_[4].value.quant) == q_unspecified)
				(yystack_[4].value.quant) = q_optional;
			break;
		}
		(yylhs.value.field) = new Field((yystack_[2].value.id).str,(yystack_[2].value.id).len,(yystack_[4].value.quant),(fieldtype_t)(yystack_[3].value.type),strtoll((yystack_[0].value.intlit).str,0,0));
	}
#line 1050 "xproto.cc"
    break;

  case 65: // Field_P: FieldSpec_P SEMI
#line 246 "xproto.y"
        { (yylhs.value.field) = (yystack_[1].value.field); }
#line 1056 "xproto.cc"
    break;

  case 66: // Field_P: FieldSpec_P OPTSTART OptionList_P OPTEND SEMI
#line 248 "xproto.y"
        { (yylhs.value.field) = (yystack_[4].value.field); (yylhs.value.field)->addOptions((yystack_[2].value.kvpair)); }
#line 1062 "xproto.cc"
    break;

  case 67: // MessageBody_P: MESSAGE IDENTIFIER LBRACE
#line 253 "xproto.y"
        { (yylhs.value.msg) = new Message((yystack_[1].value.id).str,(yystack_[1].value.id).len); }
#line 1068 "xproto.cc"
    break;

  case 68: // MessageBody_P: MessageBody_P OPTION IDENTIFIER EQUAL OptionArg_P SEMI
#line 255 "xproto.y"
        { (yylhs.value.msg) = (yystack_[5].value.msg); (yylhs.value.msg)->setOption(string((yystack_[3].value.id).str,(yystack_[3].value.id).len).c_str(),string((yystack_[1].value.id).str,(yystack_[1].value.id).len).c_str()); }
#line 1074 "xproto.cc"
    break;

  case 69: // MessageBody_P: ONEOF IDENTIFIER LBRACE
#line 257 "xproto.y"
        { (yylhs.value.msg) = new Message((yystack_[1].value.id).str,(yystack_[1].value.id).len,true); }
#line 1080 "xproto.cc"
    break;

  case 70: // MessageBody_P: MessageBody_P Field_P
#line 259 "xproto.y"
        { (yylhs.value.msg) = (yystack_[1].value.msg); (yystack_[1].value.msg)->addField((yystack_[0].value.field)); }
#line 1086 "xproto.cc"
    break;

  case 71: // MessageBody_P: MessageBody_P Message_P
#line 261 "xproto.y"
        { (yylhs.value.msg) = (yystack_[1].value.msg); (yystack_[1].value.msg)->addMessage((yystack_[0].value.msg)); ParsingMessage = (yystack_[1].value.msg)->getName(); }
#line 1092 "xproto.cc"
    break;

  case 72: // MessageBody_P: MessageBody_P Enum_P
#line 263 "xproto.y"
        { (yylhs.value.msg) = (yystack_[1].value.msg); (yystack_[1].value.msg)->addEnum((yystack_[0].value.edef)); }
#line 1098 "xproto.cc"
    break;

  case 73: // MessageBody_P: MessageBody_P RESERVE IntLit_P SEMI
#line 265 "xproto.y"
        { long l = strtol((yystack_[1].value.intlit).str,0,0); (yystack_[3].value.msg)->addReservation(l,l); }
#line 1104 "xproto.cc"
    break;

  case 74: // MessageBody_P: MessageBody_P RESERVE IntLit_P RANGE IntLit_P SEMI
#line 267 "xproto.y"
        { (yystack_[5].value.msg)->addReservation(strtol((yystack_[3].value.intlit).str,0,0),strtol((yystack_[1].value.intlit).str,0,0)); }
#line 1110 "xproto.cc"
    break;

  case 75: // MessageBody_P: MessageBody_P SEMI
#line 269 "xproto.y"
        { (yylhs.value.msg) = (yystack_[1].value.msg); ParsingMessage = ""; }
#line 1116 "xproto.cc"
    break;

  case 76: // Message_P: MessageBody_P RBRACE
#line 273 "xproto.y"
        { (yylhs.value.msg) = (yystack_[1].value.msg); }
#line 1122 "xproto.cc"
    break;

  case 77: // File_P: Message_P
#line 277 "xproto.y"
        { (yylhs.value.file) = drv.getFile(); (yylhs.value.file)->addMessage((yystack_[0].value.msg)); }
#line 1128 "xproto.cc"
    break;

  case 78: // File_P: Target_P
#line 279 "xproto.y"
        { (yylhs.value.file) = drv.getFile(); (yylhs.value.file)->addOptions((yystack_[0].value.options)); }
#line 1134 "xproto.cc"
    break;

  case 79: // File_P: OPTION IDENTIFIER EQUAL OptionArg_P SEMI
#line 281 "xproto.y"
        { (yylhs.value.file) = drv.getFile(); (yylhs.value.file)->setOption((yystack_[3].value.id).str,(yystack_[3].value.id).len,(yystack_[1].value.id).str,(yystack_[1].value.id).len); }
#line 1140 "xproto.cc"
    break;

  case 80: // File_P: OPTION NODEREF COLON OptionList_P SEMI
#line 283 "xproto.y"
        { (yylhs.value.file) = drv.getFile(); (yylhs.value.file)->getOptions()->add(string((yystack_[3].value.id).str,(yystack_[3].value.id).len),(yystack_[1].value.kvpair)); }
#line 1146 "xproto.cc"
    break;

  case 81: // File_P: Enum_P
#line 285 "xproto.y"
        { (yylhs.value.file) = drv.getFile(); (yylhs.value.file)->addEnum((yystack_[0].value.edef)); drv.setFile((yylhs.value.file)); }
#line 1152 "xproto.cc"
    break;

  case 82: // File_P: File_P Message_P
#line 287 "xproto.y"
        { (yystack_[1].value.file)->addMessage((yystack_[0].value.msg)); (yylhs.value.file) = (yystack_[1].value.file); }
#line 1158 "xproto.cc"
    break;

  case 83: // File_P: File_P Enum_P
#line 289 "xproto.y"
        { (yystack_[1].value.file)->addEnum((yystack_[0].value.edef)); }
#line 1164 "xproto.cc"
    break;

  case 84: // File_P: File_P Target_P
#line 291 "xproto.y"
        { (yystack_[1].value.file)->addOptions((yystack_[0].value.options)); }
#line 1170 "xproto.cc"
    break;

  case 85: // File_P: File_P OPTION IDENTIFIER EQUAL OptionArg_P SEMI
#line 293 "xproto.y"
        { (yystack_[5].value.file)->setOption((yystack_[3].value.id).str,(yystack_[3].value.id).len,(yystack_[1].value.id).str,(yystack_[1].value.id).len); (yylhs.value.file) = (yystack_[5].value.file); }
#line 1176 "xproto.cc"
    break;

  case 86: // File_P: File_P OPTION NODEREF COLON OptionList_P SEMI
#line 295 "xproto.y"
        { (yystack_[5].value.file)->getOptions()->add(string((yystack_[3].value.id).str,(yystack_[3].value.id).len),(yystack_[1].value.kvpair)); (yylhs.value.file) = (yystack_[5].value.file); }
#line 1182 "xproto.cc"
    break;


#line 1186 "xproto.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  ProtoParser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  ProtoParser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  ProtoParser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // ProtoParser::context.
  ProtoParser::context::context (const ProtoParser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  ProtoParser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
  ProtoParser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  ProtoParser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const signed char ProtoParser::yypact_ninf_ = -54;

  const signed char ProtoParser::yytable_ninf_ = -1;

  const signed char
  ProtoParser::yypact_[] =
  {
      27,    18,   -39,    -1,    14,    -4,   -54,     0,   -54,    50,
     -54,    72,    26,    25,     5,    38,    43,    49,   -54,    77,
      53,    80,    74,   -54,    81,    76,   -54,   -54,   -54,    55,
     -54,   -54,    -6,   -54,    68,   -54,   -54,   -54,    36,   -54,
     -54,   -54,   -54,    44,    78,    79,   -54,   -54,   -54,   -54,
      44,    79,   -54,    83,    55,    86,   -54,   -54,   -54,    -2,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,   -54,
      82,    79,   -54,    41,    85,   -54,   -54,   -54,   -54,   -54,
     -54,   -54,   -54,   -54,   -54,   -54,    90,    95,   -54,    -8,
     -54,    67,    44,    73,    44,   -54,    55,    91,    47,    44,
      79,   -54,   -54,   -54,    79,   -54,    93,   123,   -54,    96,
      97,    55,    98,    99,    70,   -54,   -54,    94,   -54,   -54,
     -54,   -54,   -54,   -54,    89,   102,   103,   -54
  };

  const signed char
  ProtoParser::yydefact_[] =
  {
       0,     0,     0,     0,     0,     0,    78,     0,    81,     5,
      77,     0,     0,     0,     0,     0,     0,     0,    57,     0,
       0,     0,     0,    63,     0,     0,     2,     3,     4,     0,
      76,    75,     0,    72,     0,    70,    71,     1,     0,    84,
      83,    82,    53,     0,     0,     0,    67,    59,    58,    69,
       0,     0,    55,     0,     0,     0,    38,    36,    37,     0,
      20,    21,    22,    15,    16,    17,    24,    12,    13,    14,
      26,     6,     7,     8,    30,     9,    10,    11,    28,    33,
      31,    32,    18,    19,    34,    35,    23,    25,    27,    29,
       0,     0,    65,     0,     0,    42,    48,    46,    47,    45,
      44,    43,    49,    50,    51,    52,     0,     0,    40,     0,
      39,     0,     0,     0,     0,    73,     0,     0,     0,     0,
       0,    79,    54,    80,     0,    56,     0,     0,    60,     0,
       0,     0,     0,     0,     0,    41,    62,     0,    68,    74,
      64,    66,    85,    86,     0,     0,     0,    61
  };

  const short
  ProtoParser::yypgoto_[] =
  {
     -54,   -54,   -54,   -53,    -5,   -47,   -48,   -54,   131,   -54,
     105,   -54,   -54,   -54,   106,   -54
  };

  const signed char
  ProtoParser::yydefgoto_[] =
  {
       0,    32,    90,    59,   108,   109,   106,     5,     6,     7,
       8,    34,    35,     9,    10,    11
  };

  const unsigned char
  ProtoParser::yytable_[] =
  {
      21,   113,   110,    22,   111,    60,    61,    62,    14,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
       1,     2,   123,    18,   124,     3,     4,    23,   115,    84,
      85,    46,   116,    19,   118,    15,    16,    24,    20,    86,
      87,    88,    89,    25,     2,    26,    27,    28,     3,     4,
      29,    17,    42,   130,   126,    12,   129,    43,    45,    44,
      13,   133,    37,   134,    47,    38,     2,    42,   140,    48,
       3,     4,   119,    93,    44,    49,   132,    30,    94,   124,
      31,    95,    96,    97,    98,    99,    51,   100,   101,   102,
     103,   104,   105,    56,    57,    58,    91,   125,    92,   124,
     143,   127,   124,   128,    33,    36,    40,    41,    50,   135,
      52,    53,    54,    55,   112,   107,    19,   114,   120,   117,
     121,   122,   131,   136,   137,   144,   138,   139,   141,   142,
     145,   146,    39,   147
  };

  const unsigned char
  ProtoParser::yycheck_[] =
  {
       5,    54,    50,     3,    51,    11,    12,    13,    47,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
       3,     4,    40,    37,    42,     8,     9,    37,    40,    45,
      46,    36,    44,    47,    91,    46,    47,    47,    52,    55,
      56,    57,    58,     3,     4,     5,     6,     7,     8,     9,
      10,    47,    36,   116,   112,    47,   114,    41,    43,    43,
      52,   119,     0,   120,    36,     3,     4,    36,   131,    36,
       8,     9,    41,    47,    43,    36,    39,    37,    52,    42,
      40,    47,    48,    49,    50,    51,    43,    53,    54,    55,
      56,    57,    58,    48,    49,    50,    38,    40,    40,    42,
      40,    38,    42,    40,     9,     9,    11,    11,    41,   124,
      40,    47,    41,    47,    41,    47,    47,    41,    43,    47,
      40,    36,    41,    40,    11,    41,    40,    40,    40,    40,
      51,    39,    11,    40
  };

  const signed char
  ProtoParser::yystos_[] =
  {
       0,     3,     4,     8,     9,    66,    67,    68,    69,    72,
      73,    74,    47,    52,    47,    46,    47,    47,    37,    47,
      52,    63,     3,    37,    47,     3,     5,     6,     7,    10,
      37,    40,    60,    69,    70,    71,    73,     0,     3,    67,
      69,    73,    36,    41,    43,    43,    36,    36,    36,    36,
      41,    43,    40,    47,    41,    47,    48,    49,    50,    62,
      11,    12,    13,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    45,    46,    55,    56,    57,    58,
      61,    38,    40,    47,    52,    47,    48,    49,    50,    51,
      53,    54,    55,    56,    57,    58,    65,    47,    63,    64,
      65,    64,    41,    62,    41,    40,    44,    47,    64,    41,
      43,    40,    36,    40,    42,    40,    65,    38,    40,    65,
      62,    41,    39,    65,    64,    63,    40,    11,    40,    40,
      62,    40,    40,    40,    41,    51,    39,    40
  };

  const signed char
  ProtoParser::yyr1_[] =
  {
       0,    59,    60,    60,    60,    60,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    62,    62,    62,    63,
      64,    64,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    66,    66,    66,    66,    67,    68,    68,
      68,    68,    68,    69,    70,    71,    71,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    73,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74
  };

  const signed char
  ProtoParser::yyr2_[] =
  {
       0,     2,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     5,     3,     5,     2,     3,     3,
       5,    10,     6,     2,     5,     2,     5,     3,     6,     3,
       2,     2,     2,     4,     6,     2,     2,     1,     1,     5,
       5,     1,     2,     2,     2,     6,     6
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const ProtoParser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "'option'", "'message'",
  "'optional'", "'required'", "'repeated'", "'enum'", "'oneof'", "RESERVE", "'string'",
  "'bytes'", "'bool'", "CSTR", "'int8'", "'uint8'", "'sint8'", "'sfixed8'", "'int16'",
  "'uint16'", "'sint16'", "'sfixed16'", "'int32'", "'uint32'", "'sint32'", "'sfixed64'",
  "'int64'", "'uint64'", "'sint64'", "'sfixed32'", "'int'", "'unsigned'", "'signed'",
  "'float'", "'double'", "'{'", "'}'", "'['", "']'", "';'",
  "'='", "','", "':'", "RANGE", "MSGNAME", "ENUMNAME", "IDENTIFIER",
  "octal literal", "decimal literal", "hexadecimal literal", "string literal", "node reference", "system header", "identifier reference",
  "'fixed8'", "'fixed16'", "'fixed32'", "'fixed64'", "$accept", "Quantifier_P",
  "Type_P", "IntLit_P", "Option_P", "OptionList_P", "OptionArg_P",
  "TargetOptions_P", "Target_P", "EnumDef_P", "Enum_P", "FieldSpec_P",
  "Field_P", "MessageBody_P", "Message_P", "File_P", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  ProtoParser::yyrline_[] =
  {
       0,   103,   103,   104,   105,   106,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   141,   143,   145,   149,
     154,   156,   161,   163,   165,   167,   169,   171,   173,   175,
     177,   179,   181,   186,   188,   190,   192,   196,   201,   203,
     205,   207,   210,   214,   219,   245,   247,   252,   254,   256,
     258,   260,   262,   264,   266,   268,   272,   276,   278,   280,
     282,   284,   286,   288,   290,   292,   294
  };

  void
  ProtoParser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  ProtoParser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  ProtoParser::symbol_kind_type
  ProtoParser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const signed char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58
    };
    // Last valid token kind.
    const int code_max = 313;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return YY_CAST (symbol_kind_type, translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

} // yy
#line 1800 "xproto.cc"

#line 298 "xproto.y"


